Mike Gerwitz

Activist for User Freedom

aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
-rw-r--r--tamer/.gitignore14
-rw-r--r--tamer/Cargo.lock6
-rw-r--r--tamer/Cargo.toml11
-rw-r--r--tamer/Makefile.am34
-rw-r--r--tamer/README.md26
-rwxr-xr-xtamer/autogen.sh26
-rwxr-xr-xtamer/bootstrap23
-rw-r--r--tamer/build-aux/m4/ax_compare_version.m4177
-rwxr-xr-xtamer/build-aux/vergen44
-rw-r--r--tamer/configure.ac58
-rw-r--r--tamer/src/main.rs3
11 files changed, 422 insertions, 0 deletions
diff --git a/tamer/.gitignore b/tamer/.gitignore
new file mode 100644
index 0000000..5cbee17
--- /dev/null
+++ b/tamer/.gitignore
@@ -0,0 +1,14 @@
+# autotools- and configure-generated
+/build-aux/install-sh
+/build-aux/missing
+confdefs.h
+Makefile.in
+Makefile
+aclocal.m4
+*.cache/
+configure
+/config.*
+
+# Rust/Cargo-generated
+/target/
+
diff --git a/tamer/Cargo.lock b/tamer/Cargo.lock
new file mode 100644
index 0000000..a0f4c71
--- /dev/null
+++ b/tamer/Cargo.lock
@@ -0,0 +1,6 @@
+# This file is automatically @generated by Cargo.
+# It is not intended for manual editing.
+[[package]]
+name = "tamer"
+version = "0.0.0"
+
diff --git a/tamer/Cargo.toml b/tamer/Cargo.toml
new file mode 100644
index 0000000..2ff8db2
--- /dev/null
+++ b/tamer/Cargo.toml
@@ -0,0 +1,11 @@
+[package]
+name = "tamer"
+version = "0.0.0"
+authors = ["Mike Gerwitz <mike.gerwitz@ryansg.com>"]
+description="TAME on Rust"
+license="GPLv3+"
+edition = "2018"
+
+# See more keys and their definitions at https://doc.rust-lang.org/cargo/reference/manifest.html
+
+[dependencies]
diff --git a/tamer/Makefile.am b/tamer/Makefile.am
new file mode 100644
index 0000000..e0742ec
--- /dev/null
+++ b/tamer/Makefile.am
@@ -0,0 +1,34 @@
+## TAMER Makefile
+#
+# Copyright (C) 2014-2019 Ryan Specialty Group, LLC.
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+##
+
+path_src = src
+path_test = test
+path_aux = build-aux
+
+.DELETE_ON_ERROR:
+
+.PHONY: all
+
+all:
+ cargo build
+
+# note that 'cargo check' is something else; see 'cargo --help'
+test: check
+check-am:
+ @CARGO@ test
+
diff --git a/tamer/README.md b/tamer/README.md
new file mode 100644
index 0000000..686f2ff
--- /dev/null
+++ b/tamer/README.md
@@ -0,0 +1,26 @@
+<!---
+ Copyright (C) 2014-2019 Ryan Specialty Group, LLC.
+
+ Permission is granted to copy, distribute and/or modify this
+ document under the terms of the GNU Free Documentation License,
+ Version 1.3 or any later version published by the Free Software
+ Foundation; with no Invariant Sections, no Front-Cover Texts, and no
+ Back-Cover Texts. A copy of the license is included the file
+ COPYING.FDL.
+-->
+TAME in Rust (TAMER)
+====================
+TAME was written to help tame the complexity of developing comparative
+insurance rating systems. This project aims to tame the complexity and
+performance issues of TAME itself. TAMER is therefore more tame than TAME.
+
+TAME was originally written in XSLT. For more information about the
+project, see the [parent `README.md`](../README.md).
+
+
+## Building
+To bootstrap from the source repository, run `./bootstrap`.
+
+To configure the build for your system, run `./configure`. To build, run
+`make`. To run tests, run `make check`.
+
diff --git a/tamer/autogen.sh b/tamer/autogen.sh
new file mode 100755
index 0000000..e990e2d
--- /dev/null
+++ b/tamer/autogen.sh
@@ -0,0 +1,26 @@
+#!/bin/bash
+# Autoreconf runner
+#
+# Copyright (C) 2014-2019 Ryan Specialty Group, LLC.
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+##
+
+which autoreconf &>/dev/null || {
+ echo "\`autoreconf' not found in PATH"
+ exit 1
+}
+
+exec autoreconf -fvi
+
diff --git a/tamer/bootstrap b/tamer/bootstrap
new file mode 100755
index 0000000..878113f
--- /dev/null
+++ b/tamer/bootstrap
@@ -0,0 +1,23 @@
+#!/bin/bash
+# Bootstrap from source repository
+#
+# Copyright (C) 2014-2019 Ryan Specialty Group, LLC.
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+##
+
+set -euo pipefail
+
+./autogen.sh
+
diff --git a/tamer/build-aux/m4/ax_compare_version.m4 b/tamer/build-aux/m4/ax_compare_version.m4
new file mode 100644
index 0000000..ffb4997
--- /dev/null
+++ b/tamer/build-aux/m4/ax_compare_version.m4
@@ -0,0 +1,177 @@
+# ===========================================================================
+# https://www.gnu.org/software/autoconf-archive/ax_compare_version.html
+# ===========================================================================
+#
+# SYNOPSIS
+#
+# AX_COMPARE_VERSION(VERSION_A, OP, VERSION_B, [ACTION-IF-TRUE], [ACTION-IF-FALSE])
+#
+# DESCRIPTION
+#
+# This macro compares two version strings. Due to the various number of
+# minor-version numbers that can exist, and the fact that string
+# comparisons are not compatible with numeric comparisons, this is not
+# necessarily trivial to do in a autoconf script. This macro makes doing
+# these comparisons easy.
+#
+# The six basic comparisons are available, as well as checking equality
+# limited to a certain number of minor-version levels.
+#
+# The operator OP determines what type of comparison to do, and can be one
+# of:
+#
+# eq - equal (test A == B)
+# ne - not equal (test A != B)
+# le - less than or equal (test A <= B)
+# ge - greater than or equal (test A >= B)
+# lt - less than (test A < B)
+# gt - greater than (test A > B)
+#
+# Additionally, the eq and ne operator can have a number after it to limit
+# the test to that number of minor versions.
+#
+# eq0 - equal up to the length of the shorter version
+# ne0 - not equal up to the length of the shorter version
+# eqN - equal up to N sub-version levels
+# neN - not equal up to N sub-version levels
+#
+# When the condition is true, shell commands ACTION-IF-TRUE are run,
+# otherwise shell commands ACTION-IF-FALSE are run. The environment
+# variable 'ax_compare_version' is always set to either 'true' or 'false'
+# as well.
+#
+# Examples:
+#
+# AX_COMPARE_VERSION([3.15.7],[lt],[3.15.8])
+# AX_COMPARE_VERSION([3.15],[lt],[3.15.8])
+#
+# would both be true.
+#
+# AX_COMPARE_VERSION([3.15.7],[eq],[3.15.8])
+# AX_COMPARE_VERSION([3.15],[gt],[3.15.8])
+#
+# would both be false.
+#
+# AX_COMPARE_VERSION([3.15.7],[eq2],[3.15.8])
+#
+# would be true because it is only comparing two minor versions.
+#
+# AX_COMPARE_VERSION([3.15.7],[eq0],[3.15])
+#
+# would be true because it is only comparing the lesser number of minor
+# versions of the two values.
+#
+# Note: The characters that separate the version numbers do not matter. An
+# empty string is the same as version 0. OP is evaluated by autoconf, not
+# configure, so must be a string, not a variable.
+#
+# The author would like to acknowledge Guido Draheim whose advice about
+# the m4_case and m4_ifvaln functions make this macro only include the
+# portions necessary to perform the specific comparison specified by the
+# OP argument in the final configure script.
+#
+# LICENSE
+#
+# Copyright (c) 2008 Tim Toolan <toolan@ele.uri.edu>
+#
+# Copying and distribution of this file, with or without modification, are
+# permitted in any medium without royalty provided the copyright notice
+# and this notice are preserved. This file is offered as-is, without any
+# warranty.
+
+#serial 13
+
+dnl #########################################################################
+AC_DEFUN([AX_COMPARE_VERSION], [
+ AC_REQUIRE([AC_PROG_AWK])
+
+ # Used to indicate true or false condition
+ ax_compare_version=false
+
+ # Convert the two version strings to be compared into a format that
+ # allows a simple string comparison. The end result is that a version
+ # string of the form 1.12.5-r617 will be converted to the form
+ # 0001001200050617. In other words, each number is zero padded to four
+ # digits, and non digits are removed.
+ AS_VAR_PUSHDEF([A],[ax_compare_version_A])
+ A=`echo "$1" | sed -e 's/\([[0-9]]*\)/Z\1Z/g' \
+ -e 's/Z\([[0-9]]\)Z/Z0\1Z/g' \
+ -e 's/Z\([[0-9]][[0-9]]\)Z/Z0\1Z/g' \
+ -e 's/Z\([[0-9]][[0-9]][[0-9]]\)Z/Z0\1Z/g' \
+ -e 's/[[^0-9]]//g'`
+
+ AS_VAR_PUSHDEF([B],[ax_compare_version_B])
+ B=`echo "$3" | sed -e 's/\([[0-9]]*\)/Z\1Z/g' \
+ -e 's/Z\([[0-9]]\)Z/Z0\1Z/g' \
+ -e 's/Z\([[0-9]][[0-9]]\)Z/Z0\1Z/g' \
+ -e 's/Z\([[0-9]][[0-9]][[0-9]]\)Z/Z0\1Z/g' \
+ -e 's/[[^0-9]]//g'`
+
+ dnl # In the case of le, ge, lt, and gt, the strings are sorted as necessary
+ dnl # then the first line is used to determine if the condition is true.
+ dnl # The sed right after the echo is to remove any indented white space.
+ m4_case(m4_tolower($2),
+ [lt],[
+ ax_compare_version=`echo "x$A
+x$B" | sed 's/^ *//' | sort -r | sed "s/x${A}/false/;s/x${B}/true/;1q"`
+ ],
+ [gt],[
+ ax_compare_version=`echo "x$A
+x$B" | sed 's/^ *//' | sort | sed "s/x${A}/false/;s/x${B}/true/;1q"`
+ ],
+ [le],[
+ ax_compare_version=`echo "x$A
+x$B" | sed 's/^ *//' | sort | sed "s/x${A}/true/;s/x${B}/false/;1q"`
+ ],
+ [ge],[
+ ax_compare_version=`echo "x$A
+x$B" | sed 's/^ *//' | sort -r | sed "s/x${A}/true/;s/x${B}/false/;1q"`
+ ],[
+ dnl Split the operator from the subversion count if present.
+ m4_bmatch(m4_substr($2,2),
+ [0],[
+ # A count of zero means use the length of the shorter version.
+ # Determine the number of characters in A and B.
+ ax_compare_version_len_A=`echo "$A" | $AWK '{print(length)}'`
+ ax_compare_version_len_B=`echo "$B" | $AWK '{print(length)}'`
+
+ # Set A to no more than B's length and B to no more than A's length.
+ A=`echo "$A" | sed "s/\(.\{$ax_compare_version_len_B\}\).*/\1/"`
+ B=`echo "$B" | sed "s/\(.\{$ax_compare_version_len_A\}\).*/\1/"`
+ ],
+ [[0-9]+],[
+ # A count greater than zero means use only that many subversions
+ A=`echo "$A" | sed "s/\(\([[0-9]]\{4\}\)\{m4_substr($2,2)\}\).*/\1/"`
+ B=`echo "$B" | sed "s/\(\([[0-9]]\{4\}\)\{m4_substr($2,2)\}\).*/\1/"`
+ ],
+ [.+],[
+ AC_WARNING(
+ [invalid OP numeric parameter: $2])
+ ],[])
+
+ # Pad zeros at end of numbers to make same length.
+ ax_compare_version_tmp_A="$A`echo $B | sed 's/./0/g'`"
+ B="$B`echo $A | sed 's/./0/g'`"
+ A="$ax_compare_version_tmp_A"
+
+ # Check for equality or inequality as necessary.
+ m4_case(m4_tolower(m4_substr($2,0,2)),
+ [eq],[
+ test "x$A" = "x$B" && ax_compare_version=true
+ ],
+ [ne],[
+ test "x$A" != "x$B" && ax_compare_version=true
+ ],[
+ AC_WARNING([invalid OP parameter: $2])
+ ])
+ ])
+
+ AS_VAR_POPDEF([A])dnl
+ AS_VAR_POPDEF([B])dnl
+
+ dnl # Execute ACTION-IF-TRUE / ACTION-IF-FALSE.
+ if test "$ax_compare_version" = "true" ; then
+ m4_ifvaln([$4],[$4],[:])dnl
+ m4_ifvaln([$5],[else $5])dnl
+ fi
+]) dnl AX_COMPARE_VERSION
diff --git a/tamer/build-aux/vergen b/tamer/build-aux/vergen
new file mode 100755
index 0000000..440649b
--- /dev/null
+++ b/tamer/build-aux/vergen
@@ -0,0 +1,44 @@
+#!/bin/sh
+# Generates version string
+#
+# Copyright (C) 2012, 2013, 2014 Free Software Foundation, Inc.
+#
+# This file is part of GNU ease.js.
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+#
+# This script has been modified slightly by LoVullo Associates to support
+# TAME's versioning scheme (`v'-prefixed).
+##
+
+# for distributions
+if [ -s version ]; then
+ cat version
+ exit
+fi
+
+git rev-parse --show-toplevel >/dev/null 2>&1 || {
+ echo 'fatal: git repository is not available'
+}
+
+version=$(
+ git describe --match='v[0-9]\.*' --abbrev=7 HEAD 2>/dev/null \
+ | sed 's/^v//'
+)
+
+git update-index -q --refresh
+test -z "$( git diff-index --name-only HEAD)" || version="$version-dirty"
+
+echo -n "$version"
+
diff --git a/tamer/configure.ac b/tamer/configure.ac
new file mode 100644
index 0000000..0fc7bf4
--- /dev/null
+++ b/tamer/configure.ac
@@ -0,0 +1,58 @@
+# For use by automake and autoconf
+#
+# Copyright (C) 2014-2019 Ryan Specialty Group, LLC.
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+##
+
+m4_include([build-aux/m4/ax_compare_version.m4])
+
+# version string is dynamically generated
+m4_define([ver], m4_esyscmd(build-aux/vergen))
+m4_if(ver, [], [m4_exit(1)])
+
+AC_INIT([tame], [ver], [dev@lovullo.com])
+AC_CONFIG_AUX_DIR([build-aux])
+AM_INIT_AUTOMAKE([foreign])
+
+# provide more granular version numbers based on the version string, using
+# the format MAJOR.MINOR.REV[-SUFFIX], where SUFFIX can itself contain
+# dashes (and often will)
+m4_define([ver_split],
+ m4_split(
+ patsubst(AC_PACKAGE_VERSION, [^\([^-]+\)-], [\1.]),
+ [\.]))
+AC_SUBST(MAJOR, m4_argn(1, ver_split))
+AC_SUBST(MINOR, m4_argn(2, ver_split))
+AC_SUBST(REV, m4_argn(3, ver_split))
+AC_SUBST(SUFFIX, m4_argn(4, ver_split))
+
+AC_ARG_VAR([CARGO], [Rust Cargo executable])
+AC_CHECK_PROGS(CARGO, [cargo])
+
+test -n "$CARGO" || AC_MSG_ERROR([cargo not found])
+
+rustc_ver_req=1.39.0
+
+AC_CHECK_PROGS(RUSTC, [rustc])
+AC_MSG_CHECKING([rustc version >= $rustc_ver_req])
+rustc_version=$("$RUSTC" --version | cut -d' ' -f2)
+AX_COMPARE_VERSION([$rustc_version], [ge], [$rustc_ver_req],
+ [AC_MSG_RESULT([yes ($rustc_version)])],
+ [AC_MSG_ERROR([no ($rustc_version)])])
+
+AC_CONFIG_FILES([Makefile])
+
+AC_OUTPUT
+
diff --git a/tamer/src/main.rs b/tamer/src/main.rs
new file mode 100644
index 0000000..e7a11a9
--- /dev/null
+++ b/tamer/src/main.rs
@@ -0,0 +1,3 @@
+fn main() {
+ println!("Hello, world!");
+}